# coding: utf-8

"""
    GoodMem API

    API for interacting with the GoodMem service, providing vector-based memory storage and retrieval with multiple embedder support. The service enables creation of memory spaces, storing memories with vector representations, and efficient similarity-based retrieval.

    The version of the OpenAPI document: v1
    Contact: support@goodmem.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from goodmem_client.models.recursive_chunking_configuration import RecursiveChunkingConfiguration
from goodmem_client.models.sentence_chunking_configuration import SentenceChunkingConfiguration
from typing import Optional, Set
from typing_extensions import Self

class ChunkingConfiguration(BaseModel):
    """
    Configuration for text chunking strategy used when processing content
    """ # noqa: E501
    var_none: Optional[Dict[str, Any]] = Field(default=None, description="No chunking strategy - preserves original content as a single unit", alias="none")
    recursive: Optional[RecursiveChunkingConfiguration] = None
    sentence: Optional[SentenceChunkingConfiguration] = None
    __properties: ClassVar[List[str]] = ["none", "recursive", "sentence"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChunkingConfiguration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of recursive
        if self.recursive:
            _dict['recursive'] = self.recursive.to_dict()
        # override the default output from pydantic by calling `to_dict()` of sentence
        if self.sentence:
            _dict['sentence'] = self.sentence.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChunkingConfiguration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "none": obj.get("none"),
            "recursive": RecursiveChunkingConfiguration.from_dict(obj["recursive"]) if obj.get("recursive") is not None else None,
            "sentence": SentenceChunkingConfiguration.from_dict(obj["sentence"]) if obj.get("sentence") is not None else None
        })
        return _obj


